<?php

declare(strict_types=1);

namespace Drupal\schemadotorg_jsonld_preview;

use Drupal\Core\Render\BubbleableMetadata;
use Drupal\Core\Routing\RouteMatchInterface;

/**
 * Schema.org JSON-LD preview builder interface.
 */
interface SchemaDotOrgJsonLdPreviewBuilderInterface {

  /**
   * Build JSON-LD preview for a route.
   *
   * @param \Drupal\Core\Routing\RouteMatchInterface|null $route_match
   *   A route match.
   * @param \Drupal\Core\Render\BubbleableMetadata|null $bubbleable_metadata
   *   (optional) Object to collect JSON-LD's bubbleable metadata.
   *
   * @return array|null
   *   The JSON-LD preview  for a route or NULL if the route does not return JSON-LD.
   */
  public function build(?RouteMatchInterface $route_match = NULL, ?BubbleableMetadata $bubbleable_metadata = NULL): ?array;

}
